/* UW8 - Operator Services src/clone_info.c
 * Copyright (c) 1998 Chris Birch <uw8@othernet.org>
 * Original code and design by Michael Dabrowski <devon@othernet.org> UW7.5
 * All further GNU development and publication rights of this software are
 * granted to Chris Birch by Michael Dabrowski.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include<bot.h>

void clone_check(char *who, char *nick)
{
   struct nickinfo *current;
   char buff[100], host[100];
   int i=0, cnt=0;

   current = nickhead;
   while(current != NULL)
   {
      if(!strcasecmp(who,current->host))
      {
          i++;
          strcpy(host,current->host);
      }
       current = current->next;
   }
   if(i > clonemsg && (trusted(who, host) == -1))
   {
      send_to_server(":%s PRIVMSG %s : [%s][%d]Clones detected from %s, - This Host is Allowed\n", botnick, msg_chan, bottime(), i, host);
      return;
   }
  
   if(i > clonemsg)
   {
      cnt = maxclones - i;
      send_to_server(":%s WALLOPS :[%d]Clones detected from %s -  %d more before action taken\n", myserver, i, host, cnt);

      send_to_server(":%s PRIVMSG %s : [%s][%d]Clones detected from %s, - %d more before action taken\n", botnick, msg_chan, bottime(), i, host, cnt);
   }

   if(i >= maxclones)
   {
      sprintf(buff, "*@%s 3600 %s", host, "Cloning");
      do_gline(bot.nick, buff);
   }
}
