/* UW8 - Operator Services src/hostchk.c
 * Copyright (c) 1998 Chris Birch <uw8@othernet.org>
 * Original code and design by Michael Dabrowski <devon@othernet.org> UW7.5
 * All further GNU development and publication rights of this software are
 * granted to Chris Birch by Michael Dabrowski.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include<bot.h>

void hostchk(char *who, char *rest)
{
   struct hostchk *host;
   struct nickinfo *nick;
   char buff[500], *nwho, *helpname;
   char *userhost;
   
   nwho=nick2num(who);
   helpname = get_command_name("hostchk");
   buff[0]='\0';
   nick = nickhead;
   if(rest == NULL || rest[0] == '\0')
   {
      do_help(who, helpname);
      return;
   }
   if(strchr(rest, '@'))
   {
      send_to_server(":%s NOTICE %s :Please only use the host \n", bot.nick, who);
      return;
   }
   while(nick != NULL)
   {
      if(!wcmp(rest, nick->host) && strcasecmp(chanserv, nick->nick))
      {
           add_hostchk(nick->nick);
      }
      nick=nick->next;
   }
   host = hosthead;
   while(host != NULL)
   {
      ison(who, host->nick);
      send_to_server(":%s NOTICE %s :-\n", bot.nick, who);
      host = host->next;
   }
   free_hostchk();
}
