struct templist
{
  char channel[210];
  int level;
  struct templist *next;
};

struct mapinfo
{
  char mapline[100];
  struct mapinfo *next;
};

struct hubinfo
{
   char main[100];
   char link[100];
   struct hubinfo *next;
   struct hubinfo *prev;
};

struct usernums
{
   char nick[25];
   char chars[4];
   int used;
};

struct servinfo
{
   char server[100];
   char chars;
   int used;
};

struct SERVERS
{
   char name[100];
   int port;
};

struct HELPLIST
{
   char name[30];
   long pos;
};

struct nickinfo 
{
   char nick[25];
   char user[25];
   char host[100];
   char server[100];
   char name[200];
   int is_oper;
   char modes[5];
   char away[2];
   char numeric[4];
   struct chaninfo *chanhead;
   struct nickinfo *next;
};

struct chaninfo
{
   char channel[201];
   int is_ops;
   struct chaninfo *next;
};

struct hostchk
{
   char nick[50];
   struct hostchk *next;
};

struct operinfo 
{
   char nick[25];
   int level;
   int suspend;
   long lastseen;
   struct adderinfo *adderhead;
   struct operinfo *next;
};

struct adderinfo
{
   char address[100];
   struct adderinfo *next;
};

struct flooding 
{
   char name[50];
   long time;
   int count;
   int bool;
   int kick;
};

struct bots 
{
   char nick[NICKLEN];
   char ircname[MAXDEF];
   char username[MAXDEF];
   char server[MAXDEF];
   int port;
   long lastpinged;
   int server_active;
};

struct PARSE_COMMAND
{
   char *name;
   void (*function)(char *, char *);
}; 

struct COMMANDS
{
   char name[20];
   char realname[20];
   void (*function)(char *, char *);
   int level;
   int needarg;
   int disable;
}; 

struct sortit
{
   char name[20];
   int level;
}; 

struct trustinfo
{
   char host[100];
   struct trustinfo *next;
};

struct badinfo
{
   char channel[100];
   struct badinfo *next;
};

struct secretinfo
{
   char channel[100];
   struct secretinfo *next;
};

struct cinfo
{
   char hostmask[100];
   int count;
   struct cinfo *next;
};

struct ginfo
{
   char who[100];
   char hostmask[100];
   long gtime;
   char reason[100];
   char fulltime[50];
   struct ginfo *next;
};

struct resvinfo
{
   char nick[100];
   char user[100];
   char host[100];
   char reason[100];
   struct resvinfo *next;
};

struct jupeinfo
{
   char nick[100];
   char server[100];
   int numeric;
   char reason[100];
   struct jupeinfo *next;
};
