/* UW8 - Operator Services src/opermsg.c
 * Copyright (c) 1998 Chris Birch <uw8@othernet.org>
 * Original code and design by Michael Dabrowski <devon@othernet.org> UW7.5
 * All further GNU development and publication rights of this software are
 * granted to Chris Birch by Michael Dabrowski.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include<bot.h>

void opermsg(char *who, char *rest)
{
   struct nickinfo *nick; 
   char *nwho, *helpname;

   nwho = nick2num(who);
   helpname = get_command_name("opermsg");
   if(rest == NULL || rest[0] == '\0')
   {
      do_help(who, helpname);
      return;
   }
   nick = nickhead;
   while(nick != NULL)
   {
      if (nick->is_oper)
      {
        send_to_server(":%s NOTICE %s :OPER MESG from %s: %s\n", bot.nick, nick->numeric, who, rest);
      }
      nick = nick->next;
   }
}
