/* UW8 - Operator Services src/parse_burst.c
 * Copyright (c) 1998 Chris Birch <uw8@othernet.org>
 * Original code and design by Michael Dabrowski <devon@othernet.org> UW7.5
 * All further GNU development and publication rights of this software are
 * granted to Chris Birch by Michael Dabrowski.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */           


#include <bot.h>
void parse_burst(char *who, char *rest)
{
   char *nxtusr = NULL, *keys = NULL, *modes = NULL, *stamp = NULL, *numeric = NULL, *nuser = NULL, *user = NULL, *limt = NULL;
   char *umodes = NULL, *tuser = NULL, *chan = NULL, *host = NULL, *nwho = NULL, servnum[3], *server = NULL, chkmodes[20];
   int i = 0, j = 0, ops = 0, no_add= 0;
   char *ptr[10000], *ptr1[10000], *p = NULL, *more = NULL, testmodes[10000], reason1[3], newmore[10000];

   reason1[0] = '\0';


   if(strchr(rest, ','))
   {
      if(strchr(rest, '+') && *rest != '+')
      {
         chan = strtok(rest, " ");
         stamp = strtok(NULL, " ");
         modes = strtok(NULL, " ");
         strcpy(testmodes, modes);
         if(strchr(modes, '+'))
         {
            while(modes[0] != '\0')
            {
               modes++;
               if(*modes == 'k')
               {
                  keys=strtok(NULL, " ");
               }
               if(*modes == 'l')
               {
                  limt=strtok(NULL, " ");
               }
            }
            user = strtok(NULL, " ");
         }
         else 
         {
            user = modes;
         }
      }
      else
      {
         chan = strtok(rest, " ");
         stamp = strtok(NULL, " ");
         user = strtok(NULL, " ");
         more = strtok(NULL, ",");
      }
      if((p = strtok(user, ",")) != NULL) ptr[i++] = p;
      while((p = strtok(NULL, ",")) != NULL && i < 100) ptr[i++] = p;
      ptr[i] = NULL;
      i = 0;
      while(ptr[i])
      {
         if(strstr(ptr[i], ":"))
         {
            numeric=strtok(ptr[i], ":");
            umodes=strtok(NULL, " ");
            if(strstr(umodes, "o"))
              ops = 1;
         }
         else numeric = ptr[i];
         server=num2serv(*numeric);
         nwho = num2nick(numeric);
         if(badchan(numeric,chan) == -1 && chan[0] != '+' && chan[0] != '&')
         {
            if(!strcasecmp(nwho, chanserv))
            {
               send_to_server(":%s PRIVMSG %s :unregister %s\n", bot.nick, numeric, chan);
            }
            host = getuserhost(nwho);
            send_to_server(":%s WALLOPS :Illegal Channel Join [%s] [%s] from [%s]\n", myserver, chan, nwho, host);
            send_to_server(":%s PRIVMSG %s :[%s] Illegal Channel Join [%s] [%s] from [%s]\n", bot.nick, msg_chan, bottime(), chan, nwho, host);
            send_to_server(":%s NOTICE %s :You have entered an ILLEGAL channel, leave imediately.\n", bot.nick, numeric);
            send_to_server(":%s MODE %s +smnit-o %s\n", myserver, chan, numeric);
         }
         if(secretchan(numeric,chan) == -1 && badchan(numeric,chan) == 0 && chan[0] != '+' && chan[0] != '&')
         {
            send_to_server(":%s MODE %s +s\n", myserver, chan);
         }
         if(!strcasecmp(chan, msg_chan)) msgchan_time = atol(stamp);
         add_joininfo(chan, numeric, ops);
         i++;
      }
   }
   else
   {
      if(strchr(rest, '+') && *rest != '+')
      {
         chan = strtok(rest, " ");
         stamp = strtok(NULL, " ");
         modes = strtok(NULL, " ");
         strcpy(testmodes, modes);
         if(strchr(modes, '+'))
         {
            while(modes[0] != '\0')
            {
               modes++;
               if(*modes == 'k')
               {
                  keys=strtok(NULL, " ");
               }
               if(*modes == 'l')
               {
                  limt=strtok(NULL, " ");
               }
            }
            user = strtok(NULL, " ");
            if(strstr(user, ":"))
            {
               numeric=strtok(user, ":");
               umodes=strtok(NULL, " ");
               if(strstr(umodes, "o"))
                 ops = 1;
               user = numeric;
            }
         }
         else
         {
            user = modes;
            if(strstr(user, ":"))
            {
              numeric=strtok(user, ":");
              umodes=strtok(NULL, " ");
              if(strstr(umodes, "o"))
                ops = 1;
              user = numeric;
            }
         }
      }
      else
      {
         strcpy(newmore, rest);
         chan = strtok(rest, " ");
         stamp = strtok(NULL, " ");
         user = strtok(NULL, " ");
         if(strstr(user, ":"))
         {
            if(*user == ':') *user++;
            numeric=strtok(user, ":");
	    if(numeric != NULL && *numeric != '%')
            {
               umodes=strtok(NULL, " ");
               if(strstr(umodes, "o"))
                 ops = 1;
               user = numeric;
            }
            else 
            {
               chan = strtok(newmore, " ");
               stamp = strtok(NULL, " ");
               more = strtok(NULL, ",");
               no_add = 1;
            }
         }
      }
      numeric = user;
      server=num2serv(*numeric);
      nwho = num2nick(numeric);
      if(badchan(numeric,chan) == -1 && chan[0] != '+' && chan[0] != '&')
      {
         if(!strcasecmp(nwho, chanserv))
         {
            send_to_server(":%s PRIVMSG %s :unregister %s\n", bot.nick, numeric, chan);
         }
         host = getuserhost(nwho);
         send_to_server(":%s WALLOPS :Illegal Channel Join [%s] [%s] from [%s]\n", myserver, chan, nwho, host);
         send_to_server(":%s PRIVMSG %s :[%s] Illegal Channel Join [%s] [%s] from [%s]\n", bot.nick, msg_chan, bottime(), chan, nwho, host);
         send_to_server(":%s NOTICE %s :You have entered an ILLEGAL channel, leave imediately.\n", bot.nick, numeric);
         send_to_server(":%s MODE %s +smnit-o %s\n", myserver, chan, numeric);
      }
      if(secretchan(numeric,chan) == -1 && badchan(numeric,chan) == 0 && chan[0] != '+' && chan[0] != '&')
      {
         send_to_server(":%s MODE %s +s\n", myserver, chan);
      }
      if(!strcasecmp(chan, msg_chan)) msgchan_time = atol(stamp);
      if(!no_add)
        add_joininfo(chan, numeric, ops);
   }
}
