/* UW8 - Operator Services src/clearban.c
 * Copyright (c) 1998 Chris Birch <uw8@othernet.org>
 * Original code and design by Michael Dabrowski <devon@othernet.org> UW7.5
 * All further GNU development and publication rights of this software are
 * granted to Chris Birch by Michael Dabrowski.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */           


#include <bot.h>

void clearban(char *who, char *rest)
{
   char *chan;
   char *nwho;
   
   nwho = nick2num(who);
   if(rest == NULL) return;
   chan = strtok(rest, " ");
   if(*chan == '+')
   {
      send_to_server(":%s NOTICE %s :   ^BThere are no modes on a Modeless Channel^B\n", bot.nick, nwho);
      return;
   }
   if(chan_check(chan, who) == -1) return;
   send_to_server(":%s MODE %s b\n", myserver, chan);
}
